# IfcTruss

<!-- WARNING: THIS FILE WAS AUTOGENERATED! DO NOT EDIT! -->

<div>

> **Note**
>
> IfcTruss is currently in the beta stage and is subject to a feature
> freeze until the end of February. Its main goals are stabilizing the
> API and improving documentation based on user feedback.

</div>

## Purpose

IfcTruss is an open source
([LGPL-3.0-or-later](https://github.com/IfcTruss/IfcTruss/blob/main/COPYING.LESSER))
software library for creating and calculating trusses in the [Industry
Foundation Classes
(IFC)](https://www.buildingsmart.org/standards/bsi-standards/industry-foundation-classes/)
standard. More precisely, the IFC 4.3 version is supported. This version
is an [ISO
standard](https://www.buildingsmart.org/ifc-4-3-approved-as-a-final-standard/).

The following main functions are provided for building, viewing and
solving a truss model in IFC:

    ifctruss.build
    ifctruss.view
    ifctruss.solve

There are also a few additional side functions that can be used:

    ifctruss.save_ods_template
    ifctruss.save_xlsx_template
    ifctruss.build_from_ods
    ifctruss.build_from_xlsx
    ifctruss.save_result

Two solvers are available for calculating the trusses. These solvers can
also be used below without IFC:

    ifctruss.solver.direct_stiffness_method
    ifctruss.solver.calfem

Go to the [Getting
Started](https://ifctruss.github.io/IfcTruss/00_General/getting_started.html)
page to learn more about using this library.

## Feedback

If you have any bugs, improvements, or feature requests, please submit
an issue. Use the [OSArch forum](https://community.osarch.org/) to share
anything else. When you share something in the [OSArch
forum](https://community.osarch.org/), put the library name in the tag.
So that someone else has it easier, if they are looking for a post in
the [OSArch forum](https://community.osarch.org/) regarding this
library.

If you have nothing to share, however, like this library, just
[star](https://docs.github.com/en/get-started/exploring-projects-on-github/saving-repositories-with-stars)
it! This is a great encouragement for the contributors.

## Code of conduct

This project adheres to the Code of Conduct adapted from the
[Contributor Covenant](https://www.contributor-covenant.org), version
2.1, available at
<https://www.contributor-covenant.org/version/2/1/code_of_conduct.html>.

## Changelog

All notable changes to this project will be documented [in this
file](https://ifctruss.github.io/IfcTruss/04_History_and_Changelog/changelog.html).

The format is based on [Keep a
Changelog](https://keepachangelog.com/en/1.0.0/), and this project
adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## Licence

Copyright © 2023-2024 IfcTruss Contributors

This program is free software: you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program. If not, see <https://www.gnu.org/licenses/>.
